application: addKey

Namespace: microsoft.graph

Important

APIs under the /beta version in Microsoft Graph are subject to change. Use of these APIs in production applications is not supported. To determine whether an API is available in v1.0, use the Version selector.

Add a key credential to an application. This method, along with removeKey, can be used by an application to automate rolling its expiring keys.

Note

You can continue to use the Create application and Update application application operations to add and update key credentials for any application with or without a user's context.

As part of the request validation for this method, a proof of possession of an existing key is verified before the action can be performed.

Applications that don’t have any existing valid certificates (no certificates have been added yet, or all certificates have expired), won’t be able to use this service action. You can use the Update application operation to perform an update instead.

Permissions

Permission type Permissions (from least to most privileged)
Delegated (work or school account) Application.ReadWrite.All, Directory.ReadWrite.All
Delegated (personal Microsoft account) Not supported.
Application Application.ReadWrite.OwnedBy, Application.ReadWrite.All, Directory.ReadWrite.All

Note

An application does not need any specific permission to roll its own keys.

HTTP request

POST /applications/{id}/addKey

Request headers

Name Description
Authorization Bearer {token}. Required.
Content-Type application/json. Required.

Request body

In the request body, provide the following required properties.

Property Type Description
keyCredential keyCredential The new application key credential to add. The type, usage and key are required properties for this usage. Supported key types are:
  • AsymmetricX509Cert: The usage must be Verify.
  • X509CertAndPassword: The usage must be Sign
passwordCredential passwordCredential Only secretText is required to be set which should contain the password for the key. This property is required only for keys of type X509CertAndPassword. Set it to null otherwise.
proof String A self-signed JWT token used as a proof of possession of the existing keys. This JWT token must be signed using the private key of one of the application's existing valid certificates. The token should contain the following claims:
  • aud - Audience needs to be 00000002-0000-0000-c000-000000000000.
  • iss - Issuer needs to be the id of the application that is making the call.
  • nbf - Not before time.
  • exp - Expiration time should be nbf + 10 mins.

For steps to generate this proof of possession token, see Generating proof of possession tokens for rolling keys. For more information about the claim types, see Claims payload.

Response

If successful, this method returns a 200 OK response code and a new keyCredential object in the response body.

Examples

Example 1: Add a new key credential to an application

Request

The following is an example of the request.

POST https://graph.microsoft.com/beta/applications/{id}/addKey
Content-type: application/json

{
    "keyCredential": {
        "type": "AsymmetricX509Cert",
        "usage": "Verify",
        "key": "MIIDYDCCAki..."
    },
    "passwordCredential": null,
    "proof":"eyJ0eXAiOiJ..."
}

Response

The following is an example of the response.

HTTP/1.1 200 OK
Content-Type: application/json

{
    "@odata.context": "https://graph.microsoft.com/beta/$metadata#microsoft.graph.keyCredential"
}

Example 2: Add a key credential and an associated password for the key

Request

The following is an example of the request.

POST https://graph.microsoft.com/beta/applications/{id}/addKey
Content-type: application/json

{
    "keyCredential": {
        "type": "X509CertAndPassword",
        "usage": "Sign",
        "key": "MIIDYDCCAki..."
    },
    "passwordCredential": {
        "secretText": "MKTr0w1..."
    },
    "proof":"eyJ0eXAiOiJ..."
}

Response

The following is an example of the response.

HTTP/1.1 200 OK
Content-Type: application/json

{
    "@odata.context": "https://graph.microsoft.com/beta/$metadata#microsoft.graph.keyCredential"
}